Count search results
- POST also GET /{index}/_count
- POST also GET /_count
Get the number of documents matching a query.
The query can be provided either by using a simple query string as a parameter, or by defining Query DSL within the request body.
The query is optional. When no query is provided, the API uses match_all to count all the documents.
The count API supports multi-target syntax. You can run a single count API search across multiple data streams and indices.
The operation is broadcast across all shards. For each shard ID group, a replica is chosen and the search is run against it. This means that replicas increase the scalability of the count.
- Index privileges:
read
Path Parameters
-
indexIndexName | IndexNameoptional -
A comma-separated list of data streams, indices, and aliases to search. It supports wildcards (
*). To search all data streams and indices, omit this parameter or use*or_all.Leave it out to use
/_count.
Query Parameters
-
allow_no_indicesboolean · default: true If
false, the request returns an error if any wildcard expression, index alias, or_allvalue targets only missing or closed indices. This behavior applies even if the request targets other open indices. For example, a request targetingfoo*,bar*returns an error if an index starts withfoobut no index starts withbar.-
analyzerstring The analyzer to use for the query string. This parameter can be used only when the
qquery string parameter is specified.-
analyze_wildcardboolean · default: false If
true, wildcard and prefix queries are analyzed. This parameter can be used only when theqquery string parameter is specified.-
default_operatorOperator · default: or The default operator for query string query:
andoror. This parameter can be used only when theqquery string parameter is specified.-
Values:
andANDorOR -
dfstring The field to use as a default when no field prefix is given in the query string. This parameter can be used only when the
qquery string parameter is specified.-
expand_wildcardsstring ExpandWildcards · default: open The type of index that wildcard patterns can match. If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams. It supports comma-separated values, such as
open,hidden.Supported values include:
all: Match any data stream or index, including hidden ones.open: Match open, non-hidden indices. Also matches any non-hidden data stream.closed: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.hidden: Match hidden data streams and hidden indices. Must be combined withopen,closed, orboth.none: Wildcard expressions are not accepted.
-
Values:
allopenclosedhiddennone -
ignore_throttledboolean · default: truedeprecated If
true, concrete, expanded, or aliased indices are ignored when frozen.If
false, the request returns an error if it targets a missing or closed index.-
lenientboolean · default: false If
true, format-based query failures (such as providing text to a numeric field) in the query string will be ignored. This parameter can be used only when theqquery string parameter is specified.-
min_scorenumber The minimum
_scorevalue that documents must have to be included in the result.-
preferencestring The node or shard the operation should be performed on. By default, it is random.
-
routingstring Routing A custom value used to route operations to a specific shard.
-
terminate_afternumber The maximum number of documents to collect for each shard. If a query reaches this limit, Elasticsearch terminates the query early. Elasticsearch collects documents before sorting.
IMPORTANT: Use with caution. Elasticsearch applies this parameter to each shard handling the request. When possible, let Elasticsearch perform early termination automatically. Avoid specifying this parameter for requests that target data streams with backing indices across multiple data tiers.
-
qstring The query in Lucene query string syntax. This parameter cannot be used with a request body.
Request
-
queryQueryContainer -
Defines the search query using Query DSL. A request body query cannot be used with the
qquery string parameter.
Response
-
countnumberrequired -
_shardsShardStatisticsrequired -
failednumber uintrequired -
The number of shards the operation or search attempted to run on but failed.
-
successfulnumber uintrequired -
The number of shards the operation or search succeeded on.
-
totalnumber uintrequired -
The number of shards the operation or search will run on overall.
-
failuresShardFailure -
indexstring IndexName -
nodestring -
reasonErrorCauserequired -
typestringrequired -
The type of error
-
reasonstringnullable -
A human-readable explanation of the error, in English.
-
stack_tracestring -
The server stack trace. Present only if the
error_trace=trueparameter was sent with the request. -
caused_byErrorCause -
root_causeErrorCause -
suppressedErrorCause -
shardnumber -
statusstring -
primaryboolean -
skippednumber uint